/**
 * This class will implement a program that determines whether (, [, {, and <
 * (openers) are nested properly and whether they match properly. This file 
 * reads a line with openers and closers and tests if the line is balanced 
 * by pushing all openers on a stack and matching the closers by popping the 
 * stack.
 *
 * @author WRITE YOUR NAME HERE
 */
import acm.program.*; // FOR DIALOGPROGRAM CLASS
import java.awt.*;    // FOR FONT CLASS
import java.io.*;     // FOR BUFFEREDREADER AND FILEREADER CLASSES

public class Matcher extends DialogProgram{
    
    // STACK TO HOLD OPEN PARENS, BRACKETS, BRACES, AND ANGLE BRACKETS
    private static CharStack stack;
    
    
    /**
     * Entry point into program creates an object of Matcher type
     * and calls the run method in the line p.start()
     */
    public static void main(String[] args) {
        Matcher p = new Matcher();
        p.setFont(new Font("sansserif", 0, 18)); 
        p.start();
    }
    
    public void run(){
        
        String fileIn = 
            readLine("Please enter a file name to read from : ");
        
        BufferedReader rd = null;
        
        try{          
            rd= new BufferedReader(new FileReader(fileIn));
            
            String line;
            
            while ((line = rd.readLine()) != null) {
                
                // input with all non-brackets removed
                String cleanedstr;
                // result of matching brackets using a stack
                boolean allMatched;
                
                //*** TASK 1: implement the removeAllNonParens
                // method (started below) that takes the line just 
                // read as input and returns only the openers and 
                // closers with all other characters removed
                cleanedstr = removeAllNonParens(line);
                
                // create a char array to hold all the characters 
                // in the cleaned input string
                char[] stArray = cleanedstr.toCharArray();
                
                //*** TASK 2: implement the matchWithStack method
                // (started below) that consumes the array of chars from
                // cleanedstr and checks if openers are matched with
                // closers using a stack
                allMatched = matchWithStack(stArray);
                
                // After calling matchWithStack, the allMatched boolean
                // should be either true or false
                if (allMatched) {
                    println(line + " is balanced\n");
                } else {
                    println(line + " is not balanced\n");
                }
            }
        }catch(Exception e){} // exception might be generated by 
        // opening BufferedReader or by reading lines from the file
    }
    
    /**
     * *** TASK 1:  Write this method 
     *
     * This method strips all non brackets out of the input string.
     * Currently this method just returns the String as read.
     */
    public String removeAllNonParens(String str) {
        String cleanstr = str;
        System.out.println("Clean String is " + cleanstr);
        return cleanstr;
    }
    
    /**
     * *** TASK 2: Write this method 
     *
     * This method uses a stack to match {}, (), <> and []s by 
     * pushing all openers on a stack and popping them to match
     * closers
     */
    public boolean matchWithStack(char[] carr) {
        stack = new CharStack(); // empty stack before next line checked.
        boolean matched = true;
        // if either the stack is not empty by the end of this
        // method or if boolean matched has been set to false
        // no match occurred
        return stack.isEmpty() && matched;
    }
    
}
